#pragma once

#include <entt/entt.hpp>
#include "network.h"
#include "scene_manager.h"

class IsoEngine {
public:
    IsoEngine(int screenWidth, int screenHeight, Network* network);
    ~IsoEngine();

    void Initialize();
    void Run();
    void Shutdown();

    SceneManager& GetSceneManager() { return sceneManager; }

    entt::registry& GetRegistry() { return registry; }

private:
    void Update();
    void Render();

    bool isRunning = true;
    int screenWidth;
    int screenHeight;
    Network* network;
    entt::registry registry;
    SceneManager sceneManager;
};
