#pragma once

enum class UIState {
    NORMAL,
    HOVERED,
    CLICKED
};

struct UIComponent {
    std::string text;
    float width;
    float height;
    std::function<void()> onClick;
    UIState state = UIState::NORMAL;

    UIComponent(std::string text, float width, float height, std::function<void()> onClick)
        : text(std::move(text)), width(width), height(height), onClick(std::move(onClick)) {}
};